Subject: Re: bug#77151: 31.0.50; >>= is not rendered

From: Mattias Roux <[email-masked]>
Date: Fri, 21 Mar 2025 18:46:30 +0100

As Mickey says when creating an issue:

 > If you're experiencing one of the following problems:
 >
 > - Emacs crashes when you use `ligature.el`;
 > - Some ligations are visually garbled, cut off, or not rendering at all;
 > - No ligations are showing at all;
 > - Weird interactions with non-ligated characters around a ligated 
character;
 >
 > Then it's very likely the issue is with **Emacs core**, and not 
`ligature.el`. This package merely interacts
 > with the Emacs text shaping engine to configure your ligature 
settings. It does not, on its own, do any sort
 > of ligation.

That's why I created this bug report but since you asked I also created 
an issue on the ligature repo: 
https://github.com/mickeynp/ligature.el/issues/59

On 21/03/2025 2:31 PM, Eli Zaretskii wrote:
>> Date: Fri, 21 Mar 2025 13:41:57 +0100
>> From: Mattias Roux <[email-masked]>
>>
>> Hi,
>>
>>   From emacs -Q you can evaluate the following code:
>>
>> (require 'package)
>> (add-to-list 'package-archives '("melpa" . "https://melpa.org/packages/"))
>> (package-initialize)
>>
>> (set-face-font 'default "Fira Code")
>>
>> (use-package ligature
>> :ensure t
>> :config
>> ;; Enable the "www" ligature in every possible major mode
>> (ligature-set-ligatures 't '("www"))
>> ;; Enable traditional ligature support in eww-mode, if the
>> ;; `variable-pitch' face supports it
>> (ligature-set-ligatures 'eww-mode '("ff" "fi" "ffi"))
>> ;; Enable all Fira Code ligatures in programming modes
>> (ligature-set-ligatures 'prog-mode '((">" (rx (+ (or ">" "<" "|" "/" ":"
>> "=" "-"))))))
>> ;; Enables ligature checks globally in all buffers. You can also do it
>> ;; per mode with `ligature-mode'.
>> (global-ligature-mode t)
>> (message "`ligature' loaded"))
>>
>> Now, if you open /tmp/test.el and write >>=, it won't be rendered, but
>> if you add any character (like = or :) it will.
>>
>> I also tested it with emacs 30.1
> Thanks, but did you report this to the developers of the "ligature"
> package first?  If so, what did they say to indicate that this problem
> is in Emacs and not in the package?
>
> If you haven't reported this to the package developers yet, please do,
> since the package is not part of Emacs.